/*
 NINJAM AU client
 Copyright (C) 2006 Expert Sleepers
 http://www.expertsleepers.co.uk/
 
 Original NINJAM code Copyright (C) 2005 Cockos Incorporated
 http://www.ninjam.com/
 
 This is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This software is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this software; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "AUEffectBase.h"
#include "ninjampluginVersion.h"
#if AU_DEBUG_DISPATCHER
#include "AUDebugDispatcher.h"
#endif


#ifndef __ninjamplugin_h__
#define __ninjamplugin_h__

#define NUM_IN_CHANNELS (4)
#define NUM_OUT_CHANNELS (9)

#pragma mark ____ninjamplugin Parameters

#pragma mark ____ninjamplugin Properties

enum Properties {
	kPropertyNJInterface = 64000,
};

#pragma mark ____ninjamplugin 
class ninjamplugin : public AUEffectBase
{
public:
	ninjamplugin(AudioUnit component);
	~ninjamplugin();
	
    virtual UInt32				SupportedNumChannels (	const AUChannelInfo**		outInfo);
	
	virtual	ComponentResult		GetParameterValueStrings(AudioUnitScope			inScope,
														 AudioUnitParameterID		inParameterID,
														 CFArrayRef *			outStrings);
    
	virtual	ComponentResult		GetParameterInfo(AudioUnitScope			inScope,
												 AudioUnitParameterID	inParameterID,
												 AudioUnitParameterInfo	&outParameterInfo);
    
	virtual ComponentResult		GetPropertyInfo(AudioUnitPropertyID		inID,
												AudioUnitScope			inScope,
												AudioUnitElement		inElement,
												UInt32 &			outDataSize,
												Boolean	&			outWritable );
	
	virtual ComponentResult		GetProperty(AudioUnitPropertyID inID,
											AudioUnitScope		inScope,
											AudioUnitElement		inElement,
											void *			outData);
	
   	virtual	bool				SupportsTail () { return false; }

	virtual OSStatus			ProcessBufferLists(
												   AudioUnitRenderActionFlags &	ioActionFlags,
												   const AudioBufferList &			inBuffer,
												   AudioBufferList &				outBuffer,
												   UInt32							inFramesToProcess );
	
	/*! @method Version */
	virtual ComponentResult	Version() { return kninjampluginVersion; }

	int		GetNumCustomUIComponents () { return 1; }
	
	void	GetUIComponentDescs (ComponentDescription* inDescArray) {
        inDescArray[0].componentType = kAudioUnitCarbonViewComponentType;
        inDescArray[0].componentSubType = ninjamplugin_COMP_SUBTYPE;
        inDescArray[0].componentManufacturer = ninjamplugin_COMP_MANF;
        inDescArray[0].componentFlags = 0;
        inDescArray[0].componentFlagsMask = 0;
	}
	
protected:
	class njinterface*		m_pInterface;
	
	float*					m_pBuffers[NUM_OUT_CHANNELS];
	
};

#endif
