/*
 NINJAM AU client
 Copyright (C) 2006 Expert Sleepers
 http://www.expertsleepers.co.uk/
 
 Original NINJAM code Copyright (C) 2005 Cockos Incorporated
 http://www.ninjam.com/
 
 This is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This software is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this software; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "ninjamplugin.h"
#include "ninjampluginView.h"
#include "njinterface.h"


COMPONENT_ENTRY(ninjampluginView)

ninjampluginView::ninjampluginView(AudioUnitCarbonView auv)
: AUCarbonViewBase(auv)
, m_pInterface( 0 )
{
}

ninjampluginView::~ninjampluginView()
{
	if ( m_pInterface )
		m_pInterface->WindowBeingDeleted();
}

// ____________________________________________________________________________
//
OSStatus	ninjampluginView::CreateUI(Float32 xoffset, Float32 yoffset)
{
	// retrieve interface
	UInt32 dataSize = sizeof m_pInterface;
	AudioUnitGetProperty( GetEditAudioUnit(), kPropertyNJInterface, kAudioUnitScope_Global, 0, &m_pInterface, &dataSize );

    // need offsets as int's:
    int xoff = (int)xoffset;
    int yoff = (int)yoffset;
    
#if 0
	// embed the interface in the host's AU window
	m_pInterface->CreatePanel( mCarbonPane, mCarbonWindow );
#else
	// ninjam in its own window
	m_pInterface->CreatePanel( NULL, NULL );
	SizeControl( mCarbonPane, 50, 10 );
#endif
		
	return noErr;
}
