/*
 NINJAM AU client
 Copyright (C) 2006 Expert Sleepers
 http://www.expertsleepers.co.uk/
 
 Original NINJAM code Copyright (C) 2005 Cockos Incorporated
 http://www.ninjam.com/
 
 This is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This software is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this software; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

class NJClient;

class njinterface
{
public:
	njinterface( int numIns, int numOuts );
	~njinterface();
	
	void						AudioProc( const float** pIns, float** pOuts, int numIns, int numOuts, UInt32 inFramesToProcess, int sampleRate );
	
	void						CreatePanel( HIViewRef parentPane, WindowRef parentWindow );
	void						WindowBeingDeleted();
	
private:
	NJClient*					m_pClient;

	enum
	{
		kEventTerminate	= 1<<0,
	};
		
	MPTaskID					m_runThreadId;
	MPEventID					m_eventGroup;
	MPSemaphoreID				m_semaphore;
	MPCriticalRegionID			m_criticalRegion;
	
	int							m_licenceResult;
	
	WindowRef					m_window;
	bool						m_compositing;
	bool						m_ownWindow;
	
	std::string					m_connectionAttempt;
	
	int							m_sampleRate;
	
	int							m_numIns, m_numOuts;

	static OSStatus				RunThread( void *pParam );
	OSStatus					RunThreadMain();
	static int					LicenseCallback( int user32, char *licensetext );
	static void					ChatMessageCallback(int user32, NJClient *inst, char **parms, int nparms);

	static pascal OSStatus		WindowEventHandler( EventHandlerCallRef  inHandler, 
													EventRef             inEvent, 
													void*                userData );
	static OSStatus				LicenceThread( void *pParam );
	static pascal OSStatus		LicenseWindowEventHandler( EventHandlerCallRef  inHandler, 
														   EventRef             inEvent, 
														   void*                userData );
	static pascal ControlKeyFilterResult	KeyFilterCallback( ControlRef theControl, 
															   SInt16 *keyCode, SInt16 *charCode,
															   EventModifiers *modifiers );
		
	void						SendChat();
	void						Connect();
	
	void						SetStatus( const char* pString );
	
	void						MakeOutputChannels();
		
};
